SystemOrganization addCategory: #'ToolBuilder-Morphic'!

ListItemWrapper subclass: #PluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTreeItemNode commentStamp: 'ar 2/12/2005 04:37' prior: 0!
Tree item for PluggableTreeMorph.!

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
acceptDroppingObject: anotherItem
	^model dropNode: anotherItem on: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
asString
	^model printNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
balloonText
	^model balloonTextForNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:02'!
canBeDragged
	^model isDraggableNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:03'!
contents
	^model contentsOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
hasContents
	^model hasNodeContents: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:04'!
icon
	^model iconOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
wantsDroppedObject: anotherItem
	^model wantsDroppedNode: anotherItem on: self! !

ModelDependentDialogWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'statusValue buttons contentMorph applyChangesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableDialogWindow commentStamp: 'gvc 8/8/2007 14:08' prior: 0!
Pluggable form of dialog window supporting custom selector on model for applying changes along with configurable content and buttons.!

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
applyChanges
	"Apply the changes."

	super applyChanges.
	self applyChangesSelector ifNotNil: [:s |
		self model perform: s withEnoughArguments: {self}]! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector
	"Answer the value of applyChangesSelector"

	^ applyChangesSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector: anObject
	"Set the value of applyChangesSelector"

	applyChangesSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons
	"Answer the value of buttons"

	^ buttons! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons: anObject
	"Set the value of buttons"

	buttons := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:03'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:02'!
newButtons
	"Answer  the plugged buttons."

	^self buttons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/9/2007 13:36'!
newContentMorph
	"Answer the plugged content."
	
	^self contentMorph! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue
	^statusValue! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue: val
	statusValue := val! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:05'!
useDefaultOKButton
	"Set the buttons to be just an OK button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton isDefault: true}! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useDefaultOKCancelButton
	"Set the buttons to be a default OK button and a cancel button.
	Only effective before the model is set."
	
	self buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useOKDefaultCancelButton
	"Set the buttons to be an OK button and a default cancel button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton. self newCancelButton isDefault: true}! !

SystemWindow subclass: #PluggableSystemWindow
	instanceVariableNames: 'getLabelSelector getChildrenSelector children closeWindowSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableSystemWindow commentStamp: 'ar 2/11/2005 20:14' prior: 0!
A pluggable system window. Fixes the issues with label retrieval and adds support for changing children.!

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'md 8/31/2005 07:59'!
addPaneMorph: aMorph
	self addMorph: aMorph fullFrame: aMorph layoutFrame! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector
	^closeWindowSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector: aSymbol
	closeWindowSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'initialization' stamp: 'ar 9/17/2005 21:08'!
delete
	closeWindowSelector ifNotNil:[model perform: closeWindowSelector].
	super delete.
! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getLabelSelector
	^getLabelSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:53'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol.
	self update: aSymbol.! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:52'!
label
	^label contents! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:51'!
label: aString
	self setLabel: aString.! !

!PluggableSystemWindow methodsFor: 'updating' stamp: 'ar 2/11/2005 20:15'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue:[self setLabel: (model perform: getLabelSelector)].
	what == getChildrenSelector ifTrue:[
		children ifNil:[children := #()].
		self removeAllMorphsIn: children.
		children := model perform: getChildrenSelector.
		self addAllMorphs: children.
		children do:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].
	^super update: what! !

SimpleHierarchicalListMorph subclass: #PluggableTreeMorph
	instanceVariableNames: 'roots selectedWrapper getRootsSelector getChildrenSelector hasChildrenSelector getLabelSelector getIconSelector getSelectedPathSelector getHelpSelector dropItemSelector wantsDropSelector dragItemSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTreeMorph commentStamp: 'ar 2/12/2005 04:38' prior: 0!
A pluggable tree morph.!

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'mvdg 2/14/2007 14:58'!
acceptDroppingMorph: aMorph event: evt
	| item dropTarget |
	dropItemSelector ifNil:[^self].
	item := aMorph passenger.
	dropTarget := (self itemFromPoint: evt position) withoutListWrapper.
	model perform: dropItemSelector with: item with: dropTarget.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:19'!
balloonTextForNode: node
	getHelpSelector ifNil:[^nil].
	^model perform: getHelpSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 01:13'!
contentsOfNode: node
	| children |
	getChildrenSelector ifNil:[^#()].
	children := model perform: getChildrenSelector with: node item.
	^children collect:[:item| PluggableTreeItemNode with: item model: self]! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector
	^dragItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector: aSymbol
	dragItemSelector := aSymbol.
	aSymbol ifNotNil:[self dragEnabled: true].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
dropItemSelector
	^dropItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/9/2007 21:37'!
dropItemSelector: aSymbol
	dropItemSelector := aSymbol.
	aSymbol ifNotNil:[self dropEnabled: true].! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
dropNode: srcNode on: dstNode
	dropItemSelector ifNil:[^nil].
	model perform: dropItemSelector with: srcNode item with: dstNode item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector
	^getHelpSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector: aSymbol
	getHelpSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector
	^getIconSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector: aSymbol
	getIconSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector
	^getLabelSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:57'!
getMenuSelector
	^getMenuSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector
	^getRootsSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector: aSelector
	getRootsSelector := aSelector.
	self update: getRootsSelector.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector
	^getSelectedPathSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector: aSymbol
	getSelectedPathSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
hasChildrenSelector
	^hasChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
hasChildrenSelector: aSymbol
	hasChildrenSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:11'!
hasNodeContents: node
	hasChildrenSelector ifNil:[^node contents isEmpty not].
	^model perform: hasChildrenSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
iconOfNode: node
	getIconSelector ifNil:[^nil].
	^model perform: getIconSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:02'!
isDraggableNode: node
	^true! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector
	^keystrokeActionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector: aSymbol
	keystrokeActionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
printNode: node
	getLabelSelector ifNil:[^node item printString].
	^model perform: getLabelSelector with: node item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:22'!
roots
	^roots! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 01:11'!
roots: anArray
	roots := anArray collect:[:item| PluggableTreeItemNode with: item model: self].
	self list: roots.! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 17:29'!
selectPath: path in: listItem
	path isEmpty ifTrue: [^self setSelectedMorph: nil].
	listItem withSiblingsDo: [:each | 
		(each complexContents item = path first) ifTrue: [
			each isExpanded ifFalse: [
				each toggleExpandedState.
				self adjustSubmorphPositions.
			].
			each changed.
			path size = 1 ifTrue: [
				^self setSelectedMorph: each
			].
			each firstChild ifNil: [^self setSelectedMorph: nil].
			^self selectPath: path allButFirst in: each firstChild
		].
	].
	^self setSelectedMorph: nil

! !

!PluggableTreeMorph methodsFor: 'selection' stamp: 'LaurentLaffont 3/17/2010 21:41'!
setSelectedMorph: aMorph
	selectedWrapper := aMorph complexContents.
	self selection: selectedWrapper.
	setSelectionSelector ifNotNil:[
		model 
			perform: setSelectionSelector 
			with: (selectedWrapper ifNotNil:[selectedWrapper item]).
	].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'LaurentLaffont 3/17/2010 21:42'!
setSelectedSelector
	^setSelectionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'LaurentLaffont 3/17/2010 21:42'!
setSelectedSelector: aSymbol
	setSelectionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'stephaneDucasse 7/17/2010 16:39'!
startDrag: evt 
	| ddm itemMorph passenger |
	self dragEnabled
		ifTrue: [itemMorph := scroller submorphs
						detect: [:any | any highlightedForMouseDown]
						ifNone: []].
	(itemMorph isNil
			or: [evt hand hasSubmorphs])
		ifTrue: [^ self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph
		ifTrue: [self setSelectedMorph: itemMorph].
	passenger := self model perform: dragItemSelector with: itemMorph withoutListWrapper.
	passenger
		ifNotNil: [ddm := TransferMorph withPassenger: passenger from: self.
			ddm dragTransferType: #dragTransfer.
			self theme settings dragNDropWithAnimation
				ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
			evt hand grabMorph: ddm].
	evt hand releaseMouseFocus: self! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 19:11'!
update: what
	what ifNil:[^self].
	what == getRootsSelector ifTrue:[
		self roots: (model perform: getRootsSelector)
	].
	what == getSelectedPathSelector ifTrue:[
		^self selectPath: (model perform: getSelectedPathSelector)
			in: (scroller submorphs at: 1 ifAbsent: [^self]) 
	].
	^super update: what! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
wantsDropSelector
	^wantsDropSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:27'!
wantsDropSelector: aSymbol
	wantsDropSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'stephaneDucasse 7/17/2010 16:39'!
wantsDroppedMorph: aMorph event: anEvent
	aMorph dragTransferType == #dragTransfer ifFalse: [^false].
	dropItemSelector ifNil: [^false].
	wantsDropSelector ifNil: [^true].
	^ (model perform: wantsDropSelector with: aMorph passenger)! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 7/15/2005 12:11'!
wantsDroppedNode: srcNode on: dstNode
	dropItemSelector ifNil:[^false].
	wantsDropSelector ifNil:[^true].
	^(model perform: wantsDropSelector with: srcNode with: dstNode) == true! !

AlignmentMorph subclass: #PluggablePanelMorph
	instanceVariableNames: 'model getChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggablePanelMorph commentStamp: 'ar 2/11/2005 20:13' prior: 0!
A pluggable panel morph which deals with changing children.!

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector
	^getChildrenSelector! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model
	^model! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model: aModel
	model ifNotNil:[model removeDependent: self].
	model := aModel.
	model ifNotNil:[model addDependent: self].! !

!PluggablePanelMorph methodsFor: 'update' stamp: 'marcus.denker 9/14/2008 18:59'!
update: what
	what ifNil: [^self].
	what == getChildrenSelector ifTrue:[
		self removeAllMorphs.
		self addAllMorphs: (model perform: getChildrenSelector).
		self submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].! !

ToolBuilder subclass: #MorphicToolBuilder
	instanceVariableNames: 'widgets panes parentMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!MorphicToolBuilder commentStamp: 'ar 2/11/2005 15:02' prior: 0!
The Morphic tool builder.!

!MorphicToolBuilder class methodsFor: 'accessing' stamp: 'alain.plantec 5/30/2008 13:55'!
isActiveBuilder
	"Answer whether I am the currently active builder"
	^ true! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 7/17/2005 00:00'!
add: aMorph to: aParent
	aParent addMorphBack: aMorph.
	aParent isSystemWindow ifTrue:[
		aParent addPaneMorph: aMorph.
	].! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'stephaneducasse 2/3/2006 22:35'!
asFrame: aRectangle
	| frame |
	aRectangle ifNil:[^nil].
	frame := LayoutFrame new.
	frame 
		leftFraction: aRectangle left; 
		rightFraction: aRectangle right; 
		topFraction: aRectangle top; 
		bottomFraction: aRectangle bottom.
	^frame! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'btr 11/26/2006 12:49'!
buildHelpFor: widget spec: aSpec
	aSpec help
		ifNotNil: [widget setBalloonText: aSpec help]! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 8/7/2009 19:40'!
buildPluggableActionButton: aSpec
	| button |
	button := self buildPluggableButton: aSpec.
	button color: Color white.
	^button! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'StephaneDucasse 7/31/2010 19:21'!
buildPluggableButton: aSpec

	| widget label state action enabled |
	label := aSpec label.
	state := aSpec state.
	action := aSpec action.
	widget := self buttonClass 
					on: aSpec model
 					getState: (state isSymbol ifTrue: [state])
  					action: nil
 					label: (label isSymbol ifTrue: [label]).
	self register: widget id: aSpec name.
	enabled := aSpec enabled.
	enabled isSymbol
		ifTrue: [widget getEnabledSelector: enabled]
		ifFalse: [widget enabled:enabled].
	action isSymbol
		ifTrue: [widget action: action]
		ifFalse: [widget actionBlock: action].
	widget getColorSelector: aSpec color.
	widget offColor: Color white..
	self buildHelpFor: widget spec: aSpec.
	(label isSymbol or: [label == nil]) ifFalse: [widget label: label].
	self setFrame: aSpec frame in: widget.
	parent ifNotNil: [self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'AlainPlantec 3/25/2010 09:19'!
buildPluggableCodePane: aSpec
	"Install the default styler for code panes.
	Implementation note: We should just be doing something like, e.g.,
		^(self buildPluggableText: aSpec) useDefaultStyler
	Unfortunately, this will retrieve and layout the initial text twice which
	can make for a noticable performance difference when looking at some
	larger piece of code. So instead we copy the implementation from 
	buildPlugggableText: here and insert #useDefaultStyler at the right point"
	| widget |
	widget := self codePaneClass new.
	widget useDefaultStyler.
	widget on: aSpec model
				text: aSpec getText 
				accept: aSpec setText
				readSelection: aSpec selection 
				menu: aSpec menu.
	widget font: StandardFonts codeFont.
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	widget borderColor: Color lightGray.
	widget color: Color white.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'md 8/15/2005 17:55'!
buildPluggableInputField: aSpec
	| widget |
	widget := self buildPluggableText: aSpec.
	widget acceptOnCR: true.
	widget hideScrollBarsIndefinitely.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:32'!
buildPluggableList: aSpec
	| widget listClass getIndex setIndex |
	aSpec getSelected ifNil:[
		listClass := self listClass.
		getIndex := aSpec getIndex.
		setIndex := aSpec setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := aSpec getSelected.
		setIndex := aSpec setSelected.
	].
	widget := listClass on: aSpec model
				list: aSpec list
				selected: getIndex
				changeSelected: setIndex
				menu: aSpec menu
				keystroke: aSpec keyPress.
	self register: widget id: aSpec name.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	widget doubleClickSelector: aSpec doubleClick.
	widget dragItemSelector: aSpec dragItem.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget autoDeselect: aSpec autoDeselect.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableMultiSelectionList: aSpec
	| widget listClass |
	aSpec getSelected ifNotNil:[^self error:'There is no PluggableListMorphOfManyByItem'].
	listClass := self multiSelectListClass.
	widget := listClass on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	self register: widget id: aSpec name.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggablePanel: aSpec
	| widget children frame |
	widget := self panelClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget color: Color transparent.
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	self buildAll: children in: widget.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	widget layoutInset: 0.
	widget borderWidth: 0.
	widget submorphsDo:[:sm|
		(frame := sm layoutFrame) ifNotNil:[
			(frame rightFraction = 0 or:[frame rightFraction = 1]) 
				ifFalse:[frame rightOffset:1].
			(frame bottomFraction = 0 or:[frame bottomFraction = 1]) 
				ifFalse:[frame bottomOffset: 1]]].
	widget color: Color transparent.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'AlainPlantec 3/25/2010 09:20'!
buildPluggableText: aSpec
	| widget |
	widget := self textPaneClass on: aSpec model
				text: aSpec getText 
				accept: aSpec setText
				readSelection: aSpec selection 
				menu: aSpec menu.
	widget askBeforeDiscardingEdits: aSpec askBeforeDiscardingEdits.
	widget font: StandardFonts codeFont.
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	widget borderColor: Color lightGray.
	widget color: Color white.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableTree: aSpec
	| widget |
	widget := self treeClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget getSelectedPathSelector: aSpec getSelectedPath.
	widget setSelectedSelector: aSpec setSelected.
	widget getChildrenSelector: aSpec getChildren.
	widget hasChildrenSelector: aSpec hasChildren.
	widget getLabelSelector: aSpec label.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec help.
	widget getMenuSelector: aSpec menu.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getRootsSelector: aSpec roots.
	widget autoDeselect: aSpec autoDeselect.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget dragItemSelector: aSpec dragItem.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
"	panes ifNotNil:[
		aSpec roots ifNotNil:[panes add: aSpec roots].
	].	"
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableWindow: aSpec
	| widget children label |
	aSpec layout == #proportional ifFalse:[
		"This needs to be implemented - probably by adding a single pane and then the rest"
		^self error: 'Not implemented'.
	].
	widget := self windowClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	(label := aSpec label) ifNotNil:[
		label isSymbol 
			ifTrue:[widget getLabelSelector: label]
			ifFalse:[widget setLabel: label]].
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	widget closeWindowSelector: aSpec closeAction.
	panes := OrderedCollection new.
	self buildAll: children in: widget.
	self buildHelpFor: widget spec: aSpec. 
	widget bounds: (RealEstateAgent 
		initialFrameFor: widget 
		initialExtent: (aSpec extent ifNil:[widget initialExtent])
		world: self currentWorld).
	widget setUpdatablePanesFrom: panes.
	^widget! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'MarcusDenker 7/29/2010 20:37'!
buttonClass
	^ PluggableButtonMorph! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:40'!
close: aWidget
	"Close a previously opened widget"
	aWidget delete! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'stephaneDucasse 7/18/2010 12:03'!
codePaneClass
	^ PluggableTextMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'stephaneDucasse 7/18/2010 11:53'!
listByItemClass
	^ PluggableListMorphByItem! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'StephaneDucasse 7/18/2010 13:43'!
listClass
	^ PluggableListMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
menuClass
	^ MenuMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
menuItemClass
	^ MenuItemMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:14'!
multiSelectListClass
	^ PluggableListMorphOfMany! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 10/4/2009 22:47'!
open: anObject
	"Build and open the object. Answer the widget opened."
	| morph |
	anObject isMorph 
		ifTrue:[morph := anObject]
		ifFalse:[morph := self build: anObject].
	(morph isKindOf: MenuMorph)
		ifTrue:[morph popUpInWorld: World].
	(morph isKindOf: SystemWindow)
		ifTrue:[morph openInWorldExtent: morph extent]
		ifFalse:[morph openInWorld].
	^morph! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:40'!
open: anObject label: aString
	"Build an open the object, labeling it appropriately.  Answer the widget opened."
	| window |
	window := self open: anObject.
	window setLabel: aString.
	^window! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:14'!
panelClass
	^ PluggablePanelMorph! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 9/6/2009 16:14'!
register: widget id: id
	id ifNil:[^self].
	widgets ifNil:[widgets := Dictionary new].
	widgets at: id put: widget.
	widget setNameTo: id.! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:41'!
runModal: aWidget
	"Run the (previously opened) widget modally, e.g., 
	do not return control to the sender before the user has responded."
	[aWidget world notNil] whileTrue: [
		aWidget outermostWorldMorph doOneCycle.
	].
! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'dc 1/10/2008 14:17'!
setFrame: aRectangle in: widget
	| frame |
	aRectangle ifNil:[^nil].
	frame := aRectangle isRectangle
		ifTrue: [self asFrame: aRectangle]
		ifFalse: [aRectangle]. "assume LayoutFrame"
	widget layoutFrame: frame.
	widget hResizing: #spaceFill; vResizing: #spaceFill.
	(parent isSystemWindow) ifTrue:[
		widget borderWidth: 2; borderColor: #inset.
	].! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 9/16/2009 23:11'!
setLayout: layout in: widget
	layout == #proportional ifTrue:[
		widget layoutPolicy: ProportionalLayout new.
		^self].
	layout == #horizontal ifTrue:[
		widget layoutPolicy: TableLayout new.
		widget listDirection: #leftToRight.
		widget submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
		widget cellInset: 1@1.
		widget layoutInset: 1@1.
		widget color: Color transparent.
		"and then some..."
		^self].
	layout == #vertical ifTrue:[
		widget layoutPolicy: TableLayout new.
		widget listDirection: #topToBottom.
		widget submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
		widget cellInset: 1@1.
		widget layoutInset: 1@1.
		widget color: Color transparent.
		"and then some..."
		^self].
	^self error: 'Unknown layout: ', layout.! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'StephaneDucasse 7/17/2010 15:44'!
textPaneClass
	^ PluggableTextMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:16'!
treeClass
	^ PluggableTreeMorph! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 7/14/2005 22:30'!
widgetAt: id ifAbsent: aBlock
	widgets ifNil:[^aBlock value].
	^widgets at: id ifAbsent: aBlock! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:16'!
windowClass
	^ PluggableSystemWindow! !
